type t
val empty : t
val of_graph : Graph.t -> t
val to_graph : t -> Graph.t

val add_vertex : t -> int -> t
val connect : t -> int -> int -> t
val is_connected : t -> int -> int -> bool
val delete_vertex : t -> int -> t
val delete_vertices: t -> IntSet.t -> t
val deg_vertices : t -> int -> IntSet.t
val deg_rel : t -> (int -> bool) -> IntSet.t
val deg_struct : t -> IntSet.t IntMap.t
val max_deg : t -> int
val max_deg_vertices : t -> IntSet.t
val max_deg_vertex : t -> int
val num_edges : t -> int
val has_vertex : t -> int -> bool
val deg : t -> int -> int
val fold_vertices :
  ('a -> int -> IntSet.t -> 'a) -> t -> 'a -> 'a
val fold_edges :
  ('a -> int -> int -> 'a) -> t -> 'a -> 'a
val fold_neighbors :
  ('a -> int -> 'a) -> t -> int -> 'a -> 'a
val vertices : t -> IntSet.t
val vertex_set : t -> IntSet.t
val new_vertex : t -> t * int
val max_vertex : t -> int
val neighbors : t -> int -> IntSet.t
val neighbors' : t -> int -> IntSet.t
val num_vertices : t -> int
val subgraph : t -> IntSet.t -> t
val complement : t -> t

(*
val sanity : t -> bool
val sanity_degree : t -> bool
*)

