(* TODO: Output vertex names *)

let output_graph dotfile g subgraphs =
  let filedesc = Unix.openfile dotfile [Unix.O_WRONLY; Unix.O_CREAT; Unix.O_TRUNC] 0o640 in
  let outchannel = Unix.out_channel_of_descr filedesc in
  let markvertex v =
    List.fold_left (fun accu g' -> accu || IntSet.contains (Graph.vertex_set g') v) false subgraphs in
  let markedge v1 v2 =
    List.fold_left (fun accu g' -> accu || try Graph.is_connected g' v1 v2 with Not_found -> false) false subgraphs in
  let print str = Printf.fprintf outchannel "%s" str in 
  print "graph {\n";
  print "  overlap=false;\n";
  print "  node [shape=box];\n";
  let print_vertex v = 
   if markvertex v then Printf.fprintf outchannel "  %i [fillcolor=blue,style=filled] \n" v
   else Printf.fprintf outchannel "  %i \n" v
  in
  let print_edge v1 v2 =
    if markedge v1 v2 then Printf.fprintf outchannel "  %i -- %i [color=blue,style=bold];\n" v1 v2
    else Printf.fprintf outchannel "  %i -- %i;\n" v1 v2 in
  Graph.iter_vertices (fun v nb -> print_vertex v) g;
  Graph.iter_edges (fun v1 v2 -> print_edge v1 v2) g;
  print "}\n";
  flush outchannel;
  Unix.close filedesc;
;;
